#!/bin/sh
#18.1.2010
########## 
####Modified by mfaraj57#####            
###############
VSNDMAN=$4 
################################################
DIRECTORY=`echo "$1" | sed -e "s/\/*$/\1/"`
DEBUG=$3
IMAGEFOLDER=$4
BOXTYPE=$5
#################Exit cleanup################
for sig in 0 1 2 3 6 14 15; do
	trap "cleanup $sig" $sig
done


cleanup() {
	EXIT_CODE=$?
	
	if [ $EXIT_CODE = 130 ] ; then
		echo " "
		echo "**************************"
		echo "*     Aborted by User    *"
		echo "**************************"
	fi
	if [ -s "$DIRECTORY"/swapfile_backup ] ; then 
		
		swapoff $DIRECTORY/swapfile_backup 2> /dev/null
		rm -rf $DIRECTORY/swapfile_backup
		echo " "
		echo "----------------------------------------"
		echo "deactivating an deleting swapfile"
		echo "----------------------------------------"
	fi
	
	mountedroot=`mount | grep $DIRECTORY/bi/root | cut -d " " -f3`
	mountedboot=`mount | grep $DIRECTORY/bi/boot | cut -d " " -f3`
	if [ "$mountedroot" = "$DIRECTORY/bi/root" -o "$mountedboot" = "$DIRECTORY/bi/boot" ]; then
		umount $DIRECTORY/bi/root 2> /dev/null
		umount $DIRECTORY/bi/boot 2> /dev/null
		echo " "
		echo "----------------------------------------"
		echo "umount $DIRECTORY/bi/root"
		echo "umount $DIRECTORY/bi/boot"
		echo "----------------------------------------"
	fi
	mv $DIRECTORY/bi/boot $DIRECTORY/$IMAGEFOLDER/boot
	echo "removing temporary files,please wait..."
	rm -rf $DIRECTORY/bi/secondstage.bin
	rm -rf $DIRECTORY/bi/boot
	rm -rf $DIRECTORY/bi/root
	rm -rf $DIRECTORY/bi
	      
	echo "Finished image build "
	echo "---------------------------------------------------"
	echo "scripts prepared by mfaraj57 ,based on tutorials of bassie,borsolano,marwan"
	echo "binaries used from dFlash 8.7 by gutemine"
        echo "- For questions visit: www.dreamoem.com  -"
	echo "- please attach-"
	echo "- the log from /tmp/imageBuildLog.               -"
	echo "---------------------------------------------------"

	echo "exit "$EXIT_CODE
#	echo "exit "$EXIT_CODE > /tmp/"exit-code"
	trap - 0 # Exit Handler 
	exit $EXIT_CODE
}



SWAPSIZE=$2


if [ "$SWAPSIZE" -lt 1 ]; then
SWAPSIZE=128
fi
DATE=`date +%Y-%m-%d-%H-%M`
starttime="$(date +%s)"
VSND=84


BOXTYPE=$5
if [ $BOXTYPE == "unknown" ]; then
	echo "Type of image unknown!,The name of image should include target box name(as example openpli-dm800se-23-1-2013,rename image and try again" 
	exit 1

fi
if [ $BOXTYPE = dm800 ]; then
	VSND=84
elif [ $BOXTYPE = dm800se ]; then
	VSND=84
elif [ $BOXTYPE = dm500hd ]; then

	VSND=84
elif [ $BOXTYPE = dm8000 ]; then

	VSND=84
elif [ $BOXTYPE = dm7020hd ]; then

	VSND=87	
else
	echo "Unknown model type of imane or not supported image found!!!"
	exit 1
fi	
echo " "
echo "*********************"
echo "** building original $BOXTYPE image...  **"
echo "*********************"
echo " "

echo "---------------------------------------------------------------"
############# continue ###############

listdummy=ls "$DIRECTORY"/blabla 2> /dev/null
FREESIZE=`df -m "$DIRECTORY" | tr -s " " | tail -n1 | cut -d' ' -f4 | sed "s/Available/0/`
if ! [ "$FREESIZE" -gt "128" ]; then
	echo ""$DIRECTORY" can't be used for Image Build because there is too less space left on the device!,please change the working directory"
	
	exit 1

echo "---------------------------------------------------------------"

fi

############# check free memory ###############
echo "check if 128MB are free in $DIRECTORY"
if [ "$FREESIZE" -lt "128" ]; then
		echo "Free memory space="$FREESIZE"MB,aborting imageBuild"
		echo "---------------------------------------------------------------"
		exit 1
	else
		echo "Free memory space="$FREESIZE"MB=OK"
	if [ $DEBUG = "debugon" ] 2> /dev/null ; then
		SWAPDIR=$DIRECTORY/imageBackup-Debug
		SSLDIR=$DIRECTORY/imageBackup-Debug/SSL
	else
		SWAPDIR=$DIRECTORY
		SSLDIR=$DIRECTORY
	fi
	echo "---------------------------------------------------------------"
fi

###########################


#############t##################

#######################


PLUGINPATH=/usr/lib/enigma2/python/Plugins/Extensions/TSpanel/Stools/NFIimageTools
MKFS=/usr/lib/enigma2/python/Plugins/Extensions/TSpanel/Stools/NFIimageTools/tsBackup/bin/mkfs.jffs2
BUILDIMAGE=/usr/lib/enigma2/python/Plugins/Extensions/TSpanel/Stools/NFIimageTools/tsBackup/bin/buildimage



if [ ! -f $MKFS ] ; then
#	echo $MKFS" not found in /usr/bin :("
	exit 1
fi
if [ ! -f $BUILDIMAGE ] ; then
	echo $BUILDIMAGE" not found in /usr/bin :("
	exit 1
fi

SND=secondstage-$BOXTYPE-$VSND.bin 



BACKUPIMAGE=$DIRECTORY/$IMAGEFOLDER-$DATE.nfi
rm -rf $DIRECTORY/bi
rm -rf $DIRECTORY/bi/boot
rm -rf $DIRECTORY/bi/root
mkdir -p $DIRECTORY/bi
mkdir -p $DIRECTORY/$BOXTYPE 
mkdir -p $DIRECTORY/$BOXTYPE/ssl
mv $DIRECTORY/$IMAGEFOLDER/boot $DIRECTORY/bi/boot



if [ $BOXTYPE = dm800 ]; then
	OPTIONS="--eraseblock=0x4000 -n -l"        
	
elif [ $BOXTYPE = dm800se ]; then
        OPTIONS="--eraseblock=0x4000 -n -l"
	
elif [ $BOXTYPE = dm500hd ]; then
        OPTIONS="--eraseblock=0x4000 -n -l"
elif [ $BOXTYPE = dm8000 ]; then
	
	
	OPTIONS="--eraseblock=0x20000 -n -l"	

else
	echo "Unknown model type of image or not supported image found!!!"
	exit 1
fi 

TMPIMAGEFOLDER=$DIRECTORY/$IMAGEFOLDER                                  



if [ -f $DIRECTORY/$BOXTYPE/ssl/$SND ] ; then
  cp -r $DIRECTORY/$BOXTYPE/ssl/$SND $DIRECTORY/bi/main.bin.gz 2> /dev/null
  echo "Secondstageloader found  ,use $SND"
else
  echo "...Download" $SND
  wget -q http://sources.dreamboxupdate.com/download/7020/$SND -O $DIRECTORY/$BOXTYPE/ssl/$SND > /dev/null
###############################
	if [ -f $DIRECTORY/$BOXTYPE/ssl/$SND ] ; then
		cp -r $DIRECTORY/$BOXTYPE/ssl/$SND $DIRECTORY/bi/main.bin.gz 2> /dev/null
	else
		echo ""
		echo "##############################################################"
		echo "# "$SND" couldn't be downloaded #"
		echo "# maybe your Box or dreamboxupdates is offline    #"
		echo "##############################################################"
		echo ""
		exit 1
	fi
fi
###############  #################

echo "---------------------------------------------------------------"

echo "---------------------------------------------------------------"

case "$DIRECTORY" in
	/media/net* )
		echo "Skipping SWAP-creation because the Build will be done to a network device"
	;;
	* )
		echo "Checking free memory, about "$SWAPSIZE"MB will bee needed"
let MEMFREE=`free | grep Total | tr -s " " | cut -d " " -f 4 `/1024
  if [ "$MEMFREE" -lt $SWAPSIZE ]; then
  echo "Memory is smaller than "$SWAPSIZE"MB, imageBuild has to create a swapfile"
echo "---------------------------------------------------------------"
  
  echo "Creating swapfile on $DIRECTORY with "$SWAPSIZE"MB"
  dd if=/dev/zero of=$DIRECTORY/swapfile_backup bs=1024k count=$SWAPSIZE
  mkswap $DIRECTORY/swapfile_backup
  swapon $DIRECTORY/swapfile_backup
echo "---------------------------------------------------------------"
  echo "Swapfile activated"
echo "---------------------------------------------------------------"
  
else
  echo "memory="$MEMFREE"MB=OK"
fi
	;;
esac

echo "***********************************************"


echo "* Image building started at: `date +%H:%M:%S`          *"
echo "***********************************************"


#########################################
#mount -t jffs2 $MTDROOT /tmp/bi/root
#mount -t jffs2 $MTDBOOT /tmp/bi/boot

if [ -s $DIRECTORY/bi/main.bin.gz ] ; then
	echo "create boot.jffs2..."

	$MKFS --root=$DIRECTORY/bi/boot --faketime --output=$DIRECTORY/bi/boot.jffs2 $OPTIONS
		SZboot=`ls -al $DIRECTORY/bi/boot.jffs2 | awk '{print $5}'`
		echo "boot size" $SZboot
	echo "create root.jffs2..."
	$MKFS --root=$DIRECTORY/$IMAGEFOLDER --faketime --output=$DIRECTORY/bi/root.jffs2 $OPTIONS
		SZroot=`ls -al $DIRECTORY/bi/root.jffs2 | awk '{print $5}'`
	        echo "root size" $SZroot
        echo "create Secondstageloader..."

	SZssl=`ls -al $DIRECTORY/bi/main.bin.gz | awk '{print $5}'`
	#rm -rf /tmp/secondstage.bin
        echo "ssl size" $SZssl
	echo "create" $BOXTYPE "imageBuild..."
      
	if [ $BOXTYPE = "dm7025" ] ; then
		$BUILDIMAGE $DIRECTORY/bi/main.bin.gz $DIRECTORY/bi/boot.jffs2 $DIRECTORY/bi/root.jffs2 $BOXTYPE > $BACKUPIMAGE
	elif [ $BOXTYPE = "dm800se" ] ; then
		$BUILDIMAGE $DIRECTORY/bi/main.bin.gz $DIRECTORY/bi/boot.jffs2 $DIRECTORY/bi/root.jffs2 $BOXTYPE 64 > $BACKUPIMAGE
	elif [ $BOXTYPE = "dm800" ] ; then
		$BUILDIMAGE $DIRECTORY/bi/main.bin.gz $DIRECTORY/bi/boot.jffs2 $DIRECTORY/bi/root.jffs2 $BOXTYPE 64 > $BACKUPIMAGE
	elif [ $BOXTYPE = "dm8000" ] ; then
		$BUILDIMAGE $DIRECTORY/bi/main.bin.gz $DIRECTORY/bi/boot.jffs2 $DIRECTORY/bi/root.jffs2 $BOXTYPE 64 large > $BACKUPIMAGE
	elif [ $BOXTYPE = "dm7020" ] ; then
		$BUILDIMAGE $DIRECTORY/bi/main.bin.gz $DIRECTORY/bi/boot.jffs2 $DIRECTORY/bi/root.jffs2 > $BACKUPIMAGE
	elif [ $BOXTYPE = "dm600pvr" ] ; then
		$BUILDIMAGE $DIRECTORY/bi/main.bin.gz $DIRECTORY/bi/boot.jffs2 $DIRECTORY/bi/root.jffs2 $BOXTYPE > $BACKUPIMAGE
	elif [ $BOXTYPE = "dm500plus" ] ; then
		$BUILDIMAGE $DIRECTORY/bi/main.bin.gz $DIRECTORY/bi/boot.jffs2 $DIRECTORY/bi/root.jffs2 $BOXTYPE > $BACKUPIMAGE
	elif [ $BOXTYPE = "dm500hd" ] ; then
		$BUILDIMAGE $DIRECTORY/bi/main.bin.gz $DIRECTORY/bi/boot.jffs2 $DIRECTORY/bi/root.jffs2 $BOXTYPE 64 > $BACKUPIMAGE
	fi

SZimage=`ls -al $BACKUPIMAGE | awk '{print $5}'`
SZsum=`expr $SZboot "+" $SZroot "+" $SZssl`
SZdiff=`expr $SZimage "-" $SZsum`

######## ######## 
		if [ "$SZsum" -lt $SZimage ]; then
#		if [ -f $BACKUPIMAGE ] ; then
		echo "----------------------------------------------------------------------"
		echo "Image  created in:" $BACKUPIMAGE " with size "$SZsum
		echo "----------------------------------------------------------------------"
			
			echo "Machine: Dreambox $BOXTYPE" >> $DIRECTORY/$IMAGEFOLDER-$DATE-SSL-$VSND.nfo
			echo "Date: "$DATE | cut -d '@' -f1 | sed -e "s/-//g" >> $DIRECTORY/$IMAGEFOLDER-$DATE-SSL-$VSND.nfo
			echo "Issuer: $DIRECTORY" >> $DIRECTORY/$IMAGEFOLDER-$DATE-SSL-$VSND.nfo
			echo $LINK >> $DIRECTORY/$IMAGEFOLDER-$DATE-SSL-$VSND.nfo

		else
			echo "Download Error :("
			#rm -rf $DIRECTORY/$IMAGEINFO-$GP3$BOXTYPE-$DATE-SSL-$VSND.nfi
			exit 1
		fi

stoptime="$(date +%s)"
elapsed_seconds="$(expr $stoptime - $starttime)"
echo "***********************************************"
echo "* imageBuild finished at: `date +%H:%M:%S`            *"
echo "* Duration of imageBuild: $((elapsed_seconds / 60))minutes $((elapsed_seconds % 60))seconds *"
echo "***********************************************"
 
fi
exit
