#!/bin/sh
#13.12.2010
##########  modified by mfaraj57

 

VSNDMAN=$4 
################################################
DIRECTORY=`echo "$1" | sed -e "s/\/*$/\1/"`
DEBUG=$3
IMAGEFOLDER=$4
DRIVERMAIN=bcm7401.ko
DRIVERSECONDARY=bcm4506.ko
DRIVERCXD=cxd1981.ko
ENIGMAPATH=$DIRECTORY/$IMAGEFOLDER/usr/bin/enigma2
ENIGMA=enigma2
BOXTYPE=$5
#################Exit cleanup################
for sig in 0 1 2 3 6 14 15; do
	trap "cleanup $sig" $sig
done
                                                                                                                            

cleanup() {
	EXIT_CODE=$?
	if [ $EXIT_CODE = 130 ] ; then
		echo " "
		echo "**************************"
		echo "*     Aborted by User    *"
		echo "**************************"
	fi
	if [ -s "$DIRECTORY"/swapfile_backup ] ; then 
	
		swapoff $DIRECTORY/swapfile_backup 2> /dev/null
		rm -rf $DIRECTORY/swapfile_backup
		echo " "
		echo "----------------------------------------"
		echo "deactivating an deleting swapfile"
		echo "----------------------------------------"
	fi
	
	mountedroot=`mount | grep $DIRECTORY/bi/root | cut -d " " -f3`
	mountedboot=`mount | grep $DIRECTORY/bi/boot | cut -d " " -f3`
	if [ "$mountedroot" = "$DIRECTORY/bi/root" -o "$mountedboot" = "$DIRECTORY/bi/boot" ]; then
		umount $DIRECTORY/bi/root 2> /dev/null
		umount $DIRECTORY/bi/boot 2> /dev/null
		echo " "
		echo "----------------------------------------"
		echo "umount $DIRECTORY/bi/root"
		echo "umount $DIRECTORY/bi/boot"
		echo "----------------------------------------"
	fi
	echo "copying original boot,drivers and enigma2 to the image.."
	mv $DIRECTORY/bi/boot $DIRECTORY/$IMAGEFOLDER/boot
	mv $DIRECTORY/bi/drivers/$DRIVERMAIN $DIRECTORY/$IMAGEFOLDER/lib/modules/2.6.18-7.4-$BOXTYPE/extra/$DRIVERMAIN
	mv $DIRECTORY/bi/drivers/$DRIVERSECONDARY $DIRECTORY/$IMAGEFOLDER/lib/modules/2.6.18-7.4-$BOXTYPE/extra/$DRIVERSECONDARY
	mv $DIRECTORY/bi/drivers/$DRIVERCXD  $DIRECTORY/$IMAGEFOLDER/lib/modules/2.6.18-7.4-$BOXTYPE/extra/$DRIVERCXD
	mv $DIRECTORY/bi/enigma/enigma2  $DIRECTORY/$IMAGEFOLDER/usr/bin/enigma2
	echo "Removing temporary files and directories"
        rm -rf $DIRECTORY/bi/secondstage.bin
	rm -rf $DIRECTORY/bi/boot
	rm -rf $DIRECTORY/bi/root
	rm -rf $DIRECTORY/bi/drivers
	rm -rf $DIRECTORY/bi/enigma
	rm -rf $DIRECTORY/bi
	
	echo " "
	echo "---------------------------------------------------"
	echo "scripts prepared by mfaraj57 ,based on tutorials of bassie,borsolano,marwan"
	echo "binaries used from dFlash 8.7 by gutemine"
        echo "- For questions visit: www.dreamoem.com  -"
	echo "- please attach-"
	echo "- the log from /tmp/imageBuildLog.               -"
	echo "---------------------------------------------------"

	echo "exit "$EXIT_CODE
#	echo "exit "$EXIT_CODE > /tmp/"exit-code"
	trap - 0 # Exit Handler 
	exit $EXIT_CODE
}



SWAPSIZE=$2


if [ "$SWAPSIZE" -lt 1 ]; then
SWAPSIZE=128
fi
DATE=`date +%Y-%m-%d-%H-%M`
starttime="$(date +%s)"
VSND=84b


echo " "
echo "*********************"
echo "** building sim2-sunray" $BOXTYPE "image...  **"
echo "*********************"
echo " "

echo "---------------------------------------------------------------"
#############  ###############

listdummy=ls "$DIRECTORY"/blabla 2> /dev/null
FREESIZE=`df -m "$DIRECTORY" | tr -s " " | tail -n1 | cut -d' ' -f4 | sed "s/Available/0/`
if ! [ "$FREESIZE" -gt "128" ]; then
	echo ""$DIRECTORY" can't be used for Image Build because there is too less space left on the device!,please change the working directory"
	
	exit 1

echo "---------------------------------------------------------------"

fi

#############  ###############
echo "check if 128MB are free in $DIRECTORY"
if [ "$FREESIZE" -lt "128" ]; then
		echo "Free memory space="$FREESIZE"MB,aborting imageBuild"
		echo "---------------------------------------------------------------"
		exit 1
	else
		echo "Free memory space="$FREESIZE"MB=OK"
	if [ $DEBUG = "debugon" ] 2> /dev/null ; then
		SWAPDIR=$DIRECTORY/imageBackup-Debug
		SSLDIR=$DIRECTORY/imageBackup-Debug/SSL
	else
		SWAPDIR=$DIRECTORY
		SSLDIR=$DIRECTORY
	fi
	echo "---------------------------------------------------------------"
fi





PLUGINPATH=/usr/lib/enigma2/python/Plugins/Extensions/TSpanel/Stools/NFIimageTools
MKFS=/usr/lib/enigma2/python/Plugins/Extensions/TSpanel/Stools/NFIimageTools/tsBackup/bin/mkfs.jffs2
BUILDIMAGE=/usr/lib/enigma2/python/Plugins/Extensions/TSpanel/Stools/NFIimageTools/tsBackup/bin/buildimage



if [ ! -f $MKFS ] ; then
#	echo $MKFS" not found in /usr/bin :("
	exit 1
fi
if [ ! -f $BUILDIMAGE ] ; then
	echo $BUILDIMAGE" not found in /usr/bin :("
	exit 1
fi
VSND=84b
SND=secondstage-sim2-$BOXTYPE-$VSND.bin 



BACKUPIMAGE=$DIRECTORY/sim2-$IMAGEFOLDER-$DATE.nfi

rm -rf $DIRECTORY/bi
rm -rf $DIRECTORY/bi/boot
rm -rf $DIRECTORY/bi/root
echo "Creating temporary directories..."
mkdir -p $DIRECTORY/bi
mkdir -p $DIRECTORY/bi/tmp
mkdir -p $DIRECTORY/$BOXTYPE 
echo "Creating "$BOXTYPE" directory..."
mkdir -p $DIRECTORY/$BOXTYPE/drivers
mkdir -p $DIRECTORY/$BOXTYPE/enigma
mkdir -p $DIRECTORY/$BOXTYPE/ssl
#echo "Copying image to temporary folder,may take up to 2 minutes,please wait......"
#cp  -r  $DIRECTORY/$IMAGEFOLDER $DIRECTORY/bi/root
echo "moving boot from image to temporary directory......"
mv $DIRECTORY/$IMAGEFOLDER/boot $DIRECTORY/bi/boot



if [ $BOXTYPE = dm800 ]; then
	OPTIONS="--eraseblock=0x4000 -n -l"        
	DRIVERMAIN=bcm7401.ko
	DRIVERSECONDARY=bcm4506.ko
	DRIVERCXD=cxd1981.ko
elif [ $BOXTYPE = dm800se ]; then
        OPTIONS="--eraseblock=0x4000 -n -l"
	DRIVERMAIN=bcm7405.ko
	DRIVERSECONDARY=bcm4506.ko
	DRIVERCXD=cxd1981.ko
elif [ $BOXTYPE = dm500hd ]; then
        OPTIONS="--eraseblock=0x4000 -n -l"
	DRIVERMAIN=bcm7405.ko
	DRIVERSECONDARY=bcm4506.ko
	DRIVERCXD=cxd1981.ko

else
	echo "Unknown model type of image or not supported image found!!!"
	exit 1
fi 
echo $BOXTYPE " image found,downloading needed sim2 files if not avaialable for the image..."  



#VMLINUXPATH=$DIRECTORY/bi/boot/vmlinux.gz

#VMLINUXSERVERPATH=http://mfaraj57.dreamoem.net/sim2-enigma2/$BOXTYPE/vmlinux.gz
#echo "...Download sim2 vmlinux.gz..." 
#rm -rf VMLINUXPATH
#wget -q $BCMMAINSERVERPATH -O $VMLINUXSERVERPATH > /dev/null
#if [ -f $VMLINUXPATH ] ; then

		#echo "# sim2 vmlinux.gz downloaded successfully #"
#else
		#echo ""
		#echo "##############################################################"
		#echo "# sim2 vmlinux.gz couldn't be downloaded #"
		#echo "# maybe your Box or server is offline    #"
		#echo "##############################################################"
		#echo ""
		#exit 1
#fi
#chmod 755 $vmlinux.gz/enigma2
TMPIMAGEFOLDER=$DIRECTORY/$IMAGEFOLDER                                  
DRIVERPATH=$DIRECTORY/$IMAGEFOLDER/lib/modules/2.6.18-7.4-$BOXTYPE/extra
ENIGMAPATH=$DIRECTORY/$IMAGEFOLDER/usr/bin
BCMMAINSERVERPATH=http://mfaraj57.dreamoem.net/sim2-drivers/$BOXTYPE/$DRIVERMAIN
BCMSMALLSERVERPATH=http://mfaraj57.dreamoem.net/sim2-drivers/$BOXTYPE/$DRIVERSECONDARY
CXDSERVERPATH=http://mfaraj57.dreamoem.net/sim2-drivers/$BOXTYPE/$DRIVERCXD

ENIGMASERVERPATH=http://mfaraj57.dreamoem.net/sim2-enigma2/$BOXTYPE/enigma2
ENIGMAPATHPY=$DIRECTORY/$IMAGEFOLDER/usr/lib/enigma2/python/enigma.py
ENIGMASERVERPATHPY=http://mfaraj57.dreamoem.net/sim2-enigma2/$BOXTYPE/enigma.PY
echo "...copying original drivers and enigma2 from the image to temporary directory..."
cp -r $DIRECTORY/$IMAGEFOLDER/lib/modules/2.6.18-7.4-$BOXTYPE/extra/$DRIVERMAIN $DIRECTORY/bi/drivers/ 2> /dev/null
cp -r $DIRECTORY/$IMAGEFOLDER/lib/modules/2.6.18-7.4-$BOXTYPE/extra/$$DRIVERSECONDARY $DIRECTORY/bi/drivers/ 2> /dev/null
cp -r $DIRECTORY/$IMAGEFOLDER/lib/modules/2.6.18-7.4-$BOXTYPE/extra/$DRIVERCXD $DIRECTORY/bi/drivers/ 2> /dev/null
cp -r $DIRECTORY/$IMAGEFOLDER/usr/bin/enigma2 $DIRECTORY/bi/enigma/$ENIGMA 2> /dev/null
				
	#mv $DIRECTORY/bi/drivers/$DRIVERMAIN $DIRECTORY/$IMAGEFOLDER/lib/modules/2.6.18-7.4-$BOXTYPE/extra/$DRIVERMAIN
	#mv $DIRECTORY/bi/drivers/$DRIVERSECONDARY $DIRECTORY/$IMAGEFOLDER/lib/modules/2.6.18-7.4-$BOXTYPE/extra/$DRIVERSECONDARY
	#mv $DIRECTORY/bi/drivers/$DRIVERCXD  $DIRECTORY/$IMAGEFOLDER/lib/modules/2.6.18-7.4-$BOXTYPE/extra/$DRIVERCXD
	#mv $DIRECTORY/bi/enigma/enigma2  $DIRECTORY/$IMAGEFOLDER/usr/bin/enigma2
echo "removing the drivers and enigma2 files from the image."
rm -rf $DRIVERPATH/$DRIVERMAIN
rm -rf $DRIVERPATH/$DRIVERSECONDARY
rm -rf $DRIVERPATH/$DRIVERCXD
rm -rf $ENIGMAPATH/$ENIGMA

echo "Downloading sim2 drivers and enigma files if not available..."
if [ -f $DIRECTORY/$BOXTYPE/drivers/$DRIVERMAIN ] ; then

		echo "# "$DRIVERMAIN" is available ,no need to download #"
		cp -r $DIRECTORY/$BOXTYPE/drivers/$DRIVERMAIN $DRIVERPATH/$DRIVERMAIN 2> /dev/null
else
		echo "downloading...."$DRIVERMAIN
		wget -q $BCMMAINSERVERPATH -O $DIRECTORY/$BOXTYPE/drivers/$DRIVERMAIN > /dev/null
                cp -r $DIRECTORY/$BOXTYPE/drivers/$DRIVERMAIN $DRIVERPATH/$DRIVERMAIN 2> /dev/null

fi
if [ -f $DRIVERPATH/$DRIVERMAIN ] ; then

		echo "# "$DRIVERMAIN" is replaced successfully #"
else
		echo ""
		echo "##############################################################"
		echo "# "$DRIVERMAIN" couldn't be downloaded #"
		echo "# maybe your Box or server is offline    #"
		echo "##############################################################"
		echo ""
		exit 1
fi
if [ -f $DIRECTORY/$BOXTYPE/drivers/$DRIVERSECONDARY ] ; then

		echo "# "$DRIVERSECONDARY" is available,no need to download..." #"
		cp -r $DIRECTORY/$BOXTYPE/drivers/$DRIVERSECONDARY $DRIVERPATH/$DRIVERSECONDARY 2> /dev/null
else
		echo "downloading...."$DRIVERSECONDARY
		wget -q $BCMSMALLSERVERPATH -O $DIRECTORY/$BOXTYPE/drivers/$DRIVERSECONDARY > /dev/null
                cp -r $DIRECTORY/$BOXTYPE/drivers/$DRIVERMAIN $DRIVERPATH/$DRIVERSECONDARY 2> /dev/null
fi                
if [ -f $DRIVERPATH/$DRIVERSECONDARY ] ; then

		echo "# "$DRIVERSECONDARY" replaced successfully #"
else
		echo ""
		echo "##############################################################"
		echo "# "$$DRIVERSECONDARY" couldn't be downloaded #"
		echo "# maybe your Box or server is offline    #"
		echo "##############################################################"
		echo ""
		exit 1
fi
if [ -f $DIRECTORY/$BOXTYPE/drivers/$DRIVERCXD ] ; then

		echo "# "$DRIVERCXD" is available,no need to download #"
		cp -r $DIRECTORY/$BOXTYPE/drivers/$DRIVERCXD $DRIVERPATH/$DRIVERCXD 2> /dev/null
else
		echo "downloading...."$DRIVERCXD
		wget -q $CXDSERVERPATH -O $DIRECTORY/$BOXTYPE/drivers/$DRIVERCXD > /dev/null
              cp -r $DIRECTORY/$BOXTYPE/drivers/$DRIVERCXD  $DRIVERPATH/$DRIVERCXD 2> /dev/null
fi
if [ -f $DRIVERPATH/$DRIVERCXD ] ; then

		echo "# "$DRIVERCXD" replaced successfully #"
else
		echo ""
		echo "##############################################################"
		echo "# "$DRIVERCXD" couldn't be downloaded #"
		echo "# maybe your Box or server is offline    #"
		echo "##############################################################"
		echo ""
		exit 1
fi
if [ -f $DIRECTORY/$BOXTYPE/enigma/enigma2 ] ; then

		echo "# enigma2 file is available,no need to download #"
		cp -r $DIRECTORY/$BOXTYPE/enigma/enigma2 $ENIGMAPATH 2> /dev/null
else
		echo "downloading...."$ENIGMA
		wget -q $ENIGMASERVERPATH -O $DIRECTORY/$BOXTYPE/enigma/$ENIGMA > /dev/null
                cp -r $DIRECTORY/$BOXTYPE/enigma/enigma2 $ENIGMAPATH/enigma2 2> /dev/null
fi                
if [ -f $ENIGMAPATH/enigma2 ] ; then

		echo "# enigma2 replaced successfully #"
fi
		#echo ""
		#echo "##############################################################"
		#echo "# "$ENIGMA" couldn't be downloaded #"
		#echo "# maybe your Box or server is offline    #"
		#echo "##############################################################"
		#echo ""
		#exit 1
#fi
if [ -f $DIRECTORY/$BOXTYPE/enigma/enigma.py ] ; then

		echo "# enigma.py file is available,no need to download #"
		cp -r $DIRECTORY/$BOXTYPE/enigma/enigma.py $ENIGMAPATHPY 2> /dev/null
else
		echo "downloading....enigma.py" 
		wget -q $ENIGMASERVERPATHPY -O $DIRECTORY/$BOXTYPE/enigma/enigma.py" > /dev/null
                cp -r $DIRECTORY/$BOXTYPE/enigma/enigma.py $ENIGMAPATHPY/enigma.py 2> /dev/null
fi                
if [ -f $ENIGMAPATH/enigma2 ] ; then

		echo "# "$ENIGMA".py replaced successfully #"
		
#else
		#echo ""
		#echo "##############################################################"
		#echo "enigma.py couldn't be downloaded"
		#echo " maybe your Box or server is offline  "
		#echo "##############################################################"
		#echo ""
		#exit 1
fi
chmod 755 $DRIVERPATH/$DRIVERMAIN
chmod 755 $DRIVERPATH/$DRIVERCXD
chmod 755 $DRIVERPATH/$DRIVERSECONDARY
chmod 755 $ENIGMAPATH/enigma2


if [ -f $DIRECTORY/$BOXTYPE/ssl/$SND ] ; then
  cp -r $DIRECTORY/$BOXTYPE/ssl/$SND $DIRECTORY/bi/main.bin.gz 2> /dev/null
  echo "Secondstageloader found  ,use $SND"
else
  echo "...Download" $SND
  wget -q http://mfaraj57.dreamoem.net/secondstage/$SND -O $DIRECTORY/$BOXTYPE/ssl/$SND > /dev/null
  #wget -q http://sources.dreamboxupdate.com/download/7020/$SND -O $DIRECTORY/$SND > /dev/null

	if [ -f $DIRECTORY/$BOXTYPE/ssl/$SND ] ; then
	        echo $SND" downloaded successfully..copying ssl to temporary folder.."
		cp -r $DIRECTORY/$BOXTYPE/ssl/$SND $DIRECTORY/bi/main.bin.gz 2> /dev/null
                
	else
		echo ""
		echo "##############################################################"
		echo $SND" couldn't be downloaded .."
		echo "maybe your Box or dreamoem server is offline   "
		echo "##############################################################"
		echo ""
		exit 1
	fi
fi


echo "---------------------------------------------------------------"

echo "---------------------------------------------------------------"

case "$DIRECTORY" in
	/media/net* )
		echo "Skipping SWAP-creation because the Build will be done to a network device"
	;;
	* )
		echo "Checking free memory, about "$SWAPSIZE"MB will bee needed"
let MEMFREE=`free | grep Total | tr -s " " | cut -d " " -f 4 `/1024
  if [ "$MEMFREE" -lt $SWAPSIZE ]; then
  echo "Memory is smaller than "$SWAPSIZE"MB, imageBuild has to create a swapfile"
echo "---------------------------------------------------------------"

  echo "Creating swapfile on $DIRECTORY with "$SWAPSIZE"MB"
  dd if=/dev/zero of=$DIRECTORY/swapfile_backup bs=1024k count=$SWAPSIZE
  mkswap $DIRECTORY/swapfile_backup
  swapon $DIRECTORY/swapfile_backup
echo "---------------------------------------------------------------"
  echo "Swapfile activated"
echo "---------------------------------------------------------------"
 
else
  echo "memory="$MEMFREE"MB=OK"
fi
	;;
esac

echo "***********************************************"


echo "* Image building started at: `date +%H:%M:%S`          *"
echo "***********************************************"



#mount -t jffs2 $MTDROOT /tmp/bi/root
#mount -t jffs2 $MTDBOOT /tmp/bi/boot

if [ -s $DIRECTORY/bi/main.bin.gz ] ; then
	echo "create boot.jffs2..."
	$MKFS --root=$DIRECTORY/bi/boot --faketime --output=$DIRECTORY/bi/boot.jffs2 $OPTIONS
		SZboot=`ls -al $DIRECTORY/bi/boot.jffs2 | awk '{print $5}'`
		echo "boot size" $SZboot
	echo "create root.jffs2..."
	$MKFS --root=$DIRECTORY/$IMAGEFOLDER --faketime --output=$DIRECTORY/bi/root.jffs2 $OPTIONS
		SZroot=`ls -al $DIRECTORY/bi/root.jffs2 | awk '{print $5}'`
	        echo "root size" $SZroot
        echo "create Secondstageloader..."

	SZssl=`ls -al $DIRECTORY/bi/main.bin.gz | awk '{print $5}'`
	#rm -rf /tmp/secondstage.bin
        echo "ssl size" $SZssl
	echo "create" $BOXTYPE "imageBuild..."
        #FAIRMAN
	if [ $BOXTYPE = "dm7025" ] ; then
		$BUILDIMAGE $DIRECTORY/bi/main.bin.gz $DIRECTORY/bi/boot.jffs2 $DIRECTORY/bi/root.jffs2 $BOXTYPE > $BACKUPIMAGE
	elif [ $BOXTYPE = "dm800se" ] ; then
		$BUILDIMAGE $DIRECTORY/bi/main.bin.gz $DIRECTORY/bi/boot.jffs2 $DIRECTORY/bi/root.jffs2 $BOXTYPE 64 > $BACKUPIMAGE
	elif [ $BOXTYPE = "dm800" ] ; then
		$BUILDIMAGE $DIRECTORY/bi/main.bin.gz $DIRECTORY/bi/boot.jffs2 $DIRECTORY/bi/root.jffs2 $BOXTYPE 64 > $BACKUPIMAGE
	elif [ $BOXTYPE = "dm8000" ] ; then
		$BUILDIMAGE $DIRECTORY/bi/main.bin.gz $DIRECTORY/bi/boot.jffs2 $DIRECTORY/bi/root.jffs2 $BOXTYPE 64 large > $BACKUPIMAGE
	elif [ $BOXTYPE = "dm7020" ] ; then
		$BUILDIMAGE $DIRECTORY/bi/main.bin.gz $DIRECTORY/bi/boot.jffs2 $DIRECTORY/bi/root.jffs2 > $BACKUPIMAGE
	elif [ $BOXTYPE = "dm600pvr" ] ; then
		$BUILDIMAGE $DIRECTORY/bi/main.bin.gz $DIRECTORY/bi/boot.jffs2 $DIRECTORY/bi/root.jffs2 $BOXTYPE > $BACKUPIMAGE
	elif [ $BOXTYPE = "dm500plus" ] ; then
		$BUILDIMAGE $DIRECTORY/bi/main.bin.gz $DIRECTORY/bi/boot.jffs2 $DIRECTORY/bi/root.jffs2 $BOXTYPE > $BACKUPIMAGE
	elif [ $BOXTYPE = "dm500hd" ] ; then
		$BUILDIMAGE $DIRECTORY/bi/main.bin.gz $DIRECTORY/bi/boot.jffs2 $DIRECTORY/bi/root.jffs2 $BOXTYPE 64 > $BACKUPIMAGE
	fi

SZimage=`ls -al $BACKUPIMAGE | awk '{print $5}'`
SZsum=`expr $SZboot "+" $SZroot "+" $SZssl`
SZdiff=`expr $SZimage "-" $SZsum`


		if [ "$SZsum" -lt $SZimage ]; then
#		if [ -f $BACKUPIMAGE ] ; then
		echo "----------------------------------------------------------------------"
		echo "Image  created in:" $BACKUPIMAGE " with size "$SZsum
		echo "----------------------------------------------------------------------"
			
			echo "Machine: Dreambox $BOXTYPE" >> $DIRECTORY/$IMAGEFOLDER-$DATE-SSL-$VSND.nfo
			echo "Date: "$DATE | cut -d '@' -f1 | sed -e "s/-//g" >> $DIRECTORY/$IMAGEFOLDER-$DATE-SSL-$VSND.nfo
			echo "Issuer: $DIRECTORY" >> $DIRECTORY/$IMAGEFOLDER-$DATE-SSL-$VSND.nfo
			echo $LINK >> $DIRECTORY/$IMAGEFOLDER-$DATE-SSL-$VSND.nfo

		else
			echo "Download Error :("
			#rm -rf $DIRECTORY/$IMAGEINFO-$GP3$BOXTYPE-$DATE-SSL-$VSND.nfi
			exit 1
		fi

stoptime="$(date +%s)"
elapsed_seconds="$(expr $stoptime - $starttime)"
echo "***********************************************"
echo "* imageBuild finished at: `date +%H:%M:%S`            *"
echo "* Duration of imageBuild: $((elapsed_seconds / 60))minutes $((elapsed_seconds % 60))seconds *"
echo "***********************************************"

fi
exit
